package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.RmsCapacityCarrierMapper;
import com.steerinfo.dil.mapper.RmsCapacityMapper;
import com.steerinfo.dil.mapper.RmsCarrierMapper;
import com.steerinfo.dil.model.RmsCapacity;
import com.steerinfo.dil.model.RmsCapacityCarrier;
import com.steerinfo.dil.service.IRmsCapacityService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author:ZhouZhou
 * @CreateTime:2021/11/9 14:21
 * @Version:V1.0
 */
@Service(value = "rmsCapacityService")
public class RmsCapacityServiceImpl implements IRmsCapacityService {
    @Autowired
    RmsCapacityMapper rmsCapacityMapper;

    @Autowired
    RmsCarrierMapper rmsCarrierMapper;

    @Autowired
    RmsCapacityCarrierMapper rmsCapacityCarrierMapper;
    /*
    * 获取运力信息
    * */
    @Override
    public List<Map<String, Object>> getCapacityList(Map<String, Object> mapVal) {
        return rmsCapacityMapper.getCapacityList(mapVal);
    }

    /*
    * 增加运力信息
    * 如果车辆已存在  那就是更改承运商
    * */
    @Override
    public int insertCapacity(Map<String,Object> mapValue) {
        RmsCapacity rmsCapacity = new RmsCapacity();
        String capacityNumber = (String) mapValue.get("capacityNumber");
        BigDecimal carrierIds=DataChange.dataToBigDecimal(mapValue.get("carrierId"));
       // String carrierUserId = (String) mapValue.get("carrierUserId");
       // BigDecimal carrierId = rmsCarrierMapper.getCarrierIdByCarrierSSOId(carrierUserId);
        //如果车辆已存在  那就是增加承运商与车牌关系
        Integer capacityId = rmsCapacityMapper.selectBycapacityNumber(capacityNumber);
        if(capacityId != null){
            Map<String,Object> map = new HashMap<>();
            map.put("capacityId",capacityId);
            map.put("carrierId",carrierIds);
            List<RmsCapacityCarrier> rmsCapacityCarriers = rmsCapacityCarrierMapper.selectByParameters(map);
            if (rmsCapacityCarriers != null && rmsCapacityCarriers.size() != 0 && rmsCapacityCarriers.get(0).getDeleted().intValue() == 0) {
                return -1;
            }
            else {
                RmsCapacityCarrier rmsCapacityCarrier = new RmsCapacityCarrier();
                rmsCapacityCarrier.setCapacityCarrierId(rmsCapacityCarrierMapper.selectMaxId());
                rmsCapacityCarrier.setCapacityId(new BigDecimal(capacityId));
                rmsCapacityCarrier.setCarrierId(carrierIds);
                rmsCapacityCarrier.setInsertUsername("admin");
                rmsCapacityCarrier.setUpdateUsername("admin");
                rmsCapacityCarrier.setInsertTime(new Date());
                rmsCapacityCarrier.setUpdateTime(new Date());
                rmsCapacityCarrier.setDeleted(new BigDecimal(0));
                rmsCapacityCarrierMapper.insertSelective(rmsCapacityCarrier);
                return 0;
            }
        }
        rmsCapacity.setCapacityId(rmsCapacityMapper.selectCapacityId());
        RmsCapacityCarrier rmsCapacityCarrier = new RmsCapacityCarrier();
        rmsCapacityCarrier.setCapacityCarrierId(rmsCapacityCarrierMapper.selectMaxId());
        rmsCapacityCarrier.setCapacityId(rmsCapacity.getCapacityId());
        rmsCapacityCarrier.setCarrierId(carrierIds);
        rmsCapacityCarrier.setInsertUsername("admin");
        rmsCapacityCarrier.setUpdateUsername("admin");
        rmsCapacityCarrier.setInsertTime(new Date());
        rmsCapacityCarrier.setUpdateTime(new Date());
        rmsCapacityCarrier.setDeleted(new BigDecimal(0));
        rmsCapacityCarrierMapper.insertSelective(rmsCapacityCarrier);
        rmsCapacity.setCarrierId(carrierIds);
        rmsCapacity.setCapacityTypeId(DataChange.dataToBigDecimal(mapValue.get("capacityTypeId")));
        rmsCapacity.setCapacityNumber(capacityNumber);
        rmsCapacity.setCapacityCorlor((String) mapValue.get("capacityCorlor"));
        rmsCapacity.setCapacityOwneris((String)mapValue.get("capacityOwneris"));
        rmsCapacity.setCapacityVip((String)mapValue.get("capacityVip"));
        rmsCapacity.setCapacityBlacklist((String)mapValue.get("capacityBlacklist"));
        Object remark = mapValue.get("remark");
        Object capacityTel = mapValue.get("capacityTel");
        if(remark != null && (!remark.toString().equals("null") || !remark.toString().equals("undefined"))){
            rmsCapacity.setInsertUpdateRemark(remark.toString());
        }
        if(capacityTel != null && (!capacityTel.toString().equals("null") || !capacityTel.toString().equals("undefined"))){
            rmsCapacity.setCapacityTel(capacityTel.toString());
        }
        if (mapValue.containsKey("driverLicence")&&mapValue.get("driverLicence") !=null){
            rmsCapacity.setDriverLicenceUrl(mapValue.get("driverLicence").toString());
        }
        rmsCapacity.setInsertUpdateRemark(((String)mapValue.get("remark")));
        rmsCapacity.setCapacitySsoId((String) mapValue.get("ssoId"));
        rmsCapacity.setCapacityStatus(new BigDecimal(0));
        rmsCapacity.setDeleted(new BigDecimal(0));
        rmsCapacity.setInsertTime(new Date());
        rmsCapacity.setInsertUsername("admin");
        return rmsCapacityMapper.insertSelective(rmsCapacity);
    }

    /*
    * 修改运力信息
    * */
    @Override
    public int updateCapacity(Map<String,Object> map) {
        String remark="";
        String userDep ="";
        String capacityTel="";
        String capacityNumber="";
        String capacityVip="否";
        String capacityGps="否";
        if (!("".equals(map.get("remark")))&&map.get("remark")!=null){
            remark = (String) map.get("remark");
        }
        if (!("".equals(map.get("userDep")))&&map.get("userDep")!=null){
            userDep = (String) map.get("userDep");
        }
        if (!("".equals(map.get("capacityTel")))&&map.get("capacityTel")!=null){
            capacityTel = (String) map.get("capacityTel");
        }
        if (!("".equals(map.get("capacityVip")))&&map.get("capacityVip")!=null){
            capacityVip = (String) map.get("capacityVip");
        }
        if (!("".equals(map.get("capacityGps")))&&map.get("capacityGps")!=null){
            capacityGps = (String) map.get("capacityGps");
        }
        BigDecimal capacityCarrierId =DataChange.dataToBigDecimal(map.get("capacityCarrierId"));
        RmsCapacityCarrier rmsCapacityCarrier=new RmsCapacityCarrier();
        rmsCapacityCarrier.setCapacityCarrierId(capacityCarrierId);
        rmsCapacityCarrier.setInsertUpdateRemark(remark);
        rmsCapacityCarrier.setCapacityUserDep(userDep);
        //更新司机电话
        if (!("".equals(map.get("capacityNumber")))&&map.get("capacityNumber")!=null){
            capacityNumber = (String) map.get("capacityNumber");
            rmsCapacityMapper.updatecapacityTel(capacityNumber,capacityTel,capacityCarrierId,capacityVip,capacityGps);
        }
        return rmsCapacityCarrierMapper.updateByPrimaryKeySelective(rmsCapacityCarrier);
    }

    /*
    * 删除运力信息
    * */
    @Override
    public int deleteCapacity(BigDecimal id) {
        return  rmsCapacityMapper.deleteByPrimaryKey(id);
    }

    /**
     * 根据id获取运力信息
     * @param id
     * @return
     */
    @Override
    public List<Map<String, Object>> getCapacityById(BigDecimal id) {
        return rmsCapacityMapper.getCapacityById(id);
    }

    /*
    * 获取下拉框
    * */
    @Override
    public  List<Map<String,Object>> getCapacityTypeId() {
        return rmsCapacityMapper.getCapacityTypeId();
    }

    /*
    * 查询carrierSSOId是否在承运商表中存在
    * */
    @Override
    public Map<String,Object> getCarrierNameBySSOId(String carrierSSOId) {
        Map<String,Object> map= rmsCapacityMapper.getCarrierNameBySSOId(carrierSSOId);
        return map;
    }

    /**
     * 通过承运商车辆ID删除绑定关系
     * @param capacityCarrierId
     * @param
     * @return
     */
    @Override
    public int deleteCapacityCarrier(BigDecimal capacityCarrierId,String carrierSSOId) {
        return rmsCapacityMapper.updateCapacityCarrier(capacityCarrierId,carrierSSOId);
    }


    //
    @Override
    public List<Map<String, Object>> getCapacityByCapacityId(Integer id) {
        return rmsCapacityMapper.getCapacityByCapacityId(id);
    }

    //获取承运商id
    @Override
    public List<Map<String, Object>> getCarrierId() {
        return rmsCapacityMapper.getCarrierId();
    }
}
